#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icons\prog.ico
#AutoIt3Wrapper_outfile=MP3-Search.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar & Skilkor(www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Array.au3>
#include <ButtonConstants.au3>
#include <Date.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <ProgressConstants.au3>
#include <SendMessage.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)

Global $sTitle = 'MP3-Search v1.3'
Global $sVersion = '1.3.0.0'
Global $sDate = '11.08.2010'

Global $sHeader = 'Titel|Interpret|Laufzeit|Album|Jahr|MPEG-Version|Bitrate|Sample-Freq.|Dateipfad' ; Die berschriften fr das Listview
Global $sInifile = @ScriptDir & '\MP3-Search.ini' ; Inidatei

Global $iWidth = IniRead($sInifile, 'Config', 'Width', 770)
Global $iHeight = IniRead($sInifile, 'Config', 'Height', 406)
Global $iLeft = IniRead($sInifile, 'Config', 'Left', @DesktopWidth / 2 - 385)
Global $iTop = IniRead($sInifile, 'Config', 'Top', @DesktopHeight / 2 - 203)
Global $iFolderOpt = IniRead($sInifile, 'Config', 'FolderOpt', 0)
If $iFolderOpt < 0 Or $iFolderOpt > 1 Then $iFolderOpt = 0
Global $sIconPath = @ScriptDir & '\icons\'

#region Hauptfenster
Global $sStyle = BitOR($GUI_SS_DEFAULT_GUI, $WS_MAXIMIZEBOX, $WS_SIZEBOX)
Global $hGui = GUICreate($sTitle, 770, 406, $iLeft, $iTop, $sStyle) ; Hauptfenster erstellen
GUISetBkColor(0xbbbbbb)
GUISetIcon($sIconPath & 'prog.ico', 1)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')

Global $hNewList = GUICtrlCreateButton('', 10, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'NewList.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Neue Liste erstellen')
GUICtrlSetOnEvent(-1, '_NewList')
Global $hLoad = GUICtrlCreateButton('', 60, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'LoadList.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Liste laden')
GUICtrlSetOnEvent(-1, '_LoadList')
Global $hLoadCheck = GUICtrlCreateButton('', 110, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'LoadListCheck.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Liste laden (inkl. Test, ob Datei existiert)')
GUICtrlSetOnEvent(-1, '_LoadListCheck')
Global $hSave = GUICtrlCreateButton('', 160, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'SaveList.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Liste speichern')
GUICtrlSetOnEvent(-1, '_SaveList')
Global $hSearch = GUICtrlCreateButton('', 220, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'ScanAll.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Alle Festplatten nach MP3s durchsuchen')
GUICtrlSetOnEvent(-1, '_ScanDrives')
Global $hSearchPath = GUICtrlCreateButton('', 270, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'ScanFolder.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Verzeichnis nach MP3s durchsuchen')
GUICtrlSetOnEvent(-1, '_ScanFolder')
Global $hRemoveEmptyFolder = GUICtrlCreateButton('', 320, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'RemoveEmptyFolder.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Leere Unterverzeichnisse lschen (rekursiv!)')
GUICtrlSetOnEvent(-1, '_RemoveEmptyFolder')
Global $hDel = GUICtrlCreateButton('', 380, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'RemoveMark.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Markierte Eintrge aus der Liste entfernen')
GUICtrlSetOnEvent(-1, '_RemoveMark')
GUICtrlSetState(-1, $GUI_DISABLE)
Global $hCopyFiles = GUICtrlCreateButton('', 430, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'CopyFiles.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Kopiert markierte Dateien nach...')
GUICtrlSetOnEvent(-1, '_CopyFiles')
GUICtrlSetState(-1, $GUI_DISABLE)
Global $hMoveFiles = GUICtrlCreateButton('', 480, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'MoveFiles.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Verschiebt markierte Dateien nach...')
GUICtrlSetOnEvent(-1, '_MoveFiles')
GUICtrlSetState(-1, $GUI_DISABLE)
Global $hDelFiles = GUICtrlCreateButton('', 530, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'DeleteFiles.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Markierte Dateien von der Festplatte lschen')
GUICtrlSetOnEvent(-1, '_DeleteFiles')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateLabel('Markiert:', 580, 14, 48, 16, $SS_CENTER)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetResizing(-1, 512 + 32)
Global $hShowMark = GUICtrlCreateLabel('0', 580, 30, 48, 18, $SS_CENTER, $WS_EX_STATICEDGE)
GUICtrlSetBkColor(-1, 0xEEEEEE)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetResizing(-1, 512 + 32)
Global $hInfo = GUICtrlCreateButton('', 710, 2, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'Info.ico', 1)
GUICtrlSetResizing(-1, 512 + 32)
GUICtrlSetTip(-1, 'Informationen ber das Programm')
GUICtrlSetOnEvent(-1, '_ProgInfos')

Global $hListView = GUICtrlCreateListView($sHeader, 5, 55, 760, 210, $LVS_SHOWSELALWAYS, BitOR($LVS_EX_FULLROWSELECT, $WS_EX_WINDOWEDGE)) ; Listview erstellen
GUICtrlSetResizing(-1, 2 + 4 + 32 + 64)
GUICtrlSetBkColor(-1, 0xffffff)
GUICtrlSetOnEvent(-1, '_SortList')
Global $hLVHandle = GUICtrlGetHandle($hListView) ; das Handle vom Listview wird fr die UDF-Listview-Funktionen bentigt
_GUICtrlListView_SetColumnWidth($hLVHandle, 0, 180)
_GUICtrlListView_SetColumnWidth($hLVHandle, 1, 180)
_GUICtrlListView_SetColumnWidth($hLVHandle, 2, 60)
_GUICtrlListView_SetColumnWidth($hLVHandle, 3, 120)
_GUICtrlListView_SetColumnWidth($hLVHandle, 4, 60)
_GUICtrlListView_SetColumnWidth($hLVHandle, 5, 100)
_GUICtrlListView_SetColumnWidth($hLVHandle, 6, 100)
_GUICtrlListView_SetColumnWidth($hLVHandle, 7, 90)
_GUICtrlListView_SetColumnWidth($hLVHandle, 8, 800)

Global $hSearchListView = GUICtrlCreateListView($sHeader, 5, 55, 760, 210, $LVS_SHOWSELALWAYS, BitOR($LVS_EX_FULLROWSELECT, $WS_EX_WINDOWEDGE)) ; Listview erstellen
GUICtrlSetResizing(-1, 2 + 4 + 32 + 64)
GUICtrlSetBkColor(-1, 0xaaffbb)
Global $hSearchLVHandle = GUICtrlGetHandle($hSearchListView) ; das Handle vom Listview wird fr die UDF-Listview-Funktionen bentigt
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 0, 180)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 1, 180)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 2, 60)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 3, 120)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 4, 60)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 5, 100)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 6, 100)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 7, 90)
_GUICtrlListView_SetColumnWidth($hSearchLVHandle, 8, 800)
GUICtrlSetState($hSearchListView, $GUI_HIDE)

GUICtrlCreateGroup('Listensuche:', 5, 280, 370, 75)
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlCreateLabel('Suchbegriff:', 15, 302, 70, 22, $SS_RIGHT)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetResizing(-1, 512 + 64)
Global $hInput = GUICtrlCreateInput('', 90, 300, 220, 22)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetResizing(-1, 512 + 64)
Global $hInputOk = GUICtrlCreateButton('', 320, 298, 42, 42, BitOR($BS_ICON, $BS_DEFPUSHBUTTON))
GUICtrlSetImage(-1, $sIconPath & 'SearchList.ico', 1)
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlSetTip(-1, 'Suche starten')
GUICtrlSetOnEvent(-1, '_SearchList')
Global $hCaseSens = GUICtrlCreateCheckbox('Gro-/Kleinschreibung beachten', 90, 325, 220, 22)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Verzeichnisstruktur anhand der ID3-Tags erstellen:', 380, 280, 385, 75)
GUICtrlSetResizing(-1, 512 + 64)
Global $hFolderOpt[2]
$hFolderOpt[0] = GUICtrlCreateRadio('.. \ Interpret \ Dateiname', 390, 300, 220, 22)
GUICtrlSetFont(-1, 10, 400, 2, 'Arial')
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlSetTip(-1, 'Wenn der Interpret in den ID3-Tags nicht vorhanden ist' & @CR & 'wird "unbekannter Interpret" verwendet.')
$hFolderOpt[1] = GUICtrlCreateRadio('.. \ Interpret \ Album \ Dateiname', 390, 325, 220, 22)
GUICtrlSetFont(-1, 10, 400, 2, 'Arial')
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlSetTip(-1, 'Wenn der Interpret und/oder das Album in den ID3-Tags nicht vorhanden ist' & @CR & 'wird "unbekannter Interpret" bzw. "unbekanntes Album" verwendet.')
GUICtrlSetState($hFolderOpt[$iFolderOpt], $GUI_CHECKED)
Global $hAutoSortCopy = GUICtrlCreateButton('', 640, 296, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'AutoSortCopy.ico', 1)
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlSetTip(-1, 'Kopiert alle MP3-Dateien aus der Liste' & @CR & 'in die Verzeichnisstruktur (Auswahl)')
GUICtrlSetOnEvent(-1, '_AutoSortCopy')
Global $hAutoSortMove = GUICtrlCreateButton('', 700, 296, 48, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconPath & 'AutoSortMove.ico', 1)
GUICtrlSetResizing(-1, 512 + 64)
GUICtrlSetTip(-1, 'Verschiebt alle MP3-Dateien aus der Liste' & @CR & 'in die Verzeichnisstruktur (Auswahl)')
GUICtrlSetOnEvent(-1, '_AutoSortMove')
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $hProgress = GUICtrlCreateProgress(-2, 366, 774, 18, $PBS_MARQUEE)
GUICtrlSetResizing(-1, 512 + 64)

Global $aParts[3] = [300, 360, -1], $aText[3] = ['Fertig.', '0', '']
Global $hStatus = _GUICtrlStatusBar_Create($hGui, $aParts, $aText, $SBARS_SIZEGRIP)
_GUICtrlStatusBar_SetSimple($hStatus, False)
_GUICtrlStatusBar_SetMinHeight($hStatus, 20)
#endregion Hauptfenster

GUISetState(@SW_SHOW, $hGui) ; Hauptfenster sichtbar machen

Global $fStop = False, $iSearchIndex = -1, $iSelCount, $iSelOld, $aListview
HotKeySet('{ESC}', '_Stop')

Dim $aAccelKeys[1][2] = [['{DEL}', $hDel]] ; beim drcken der [Delete]-Taste wird "$hDel" ausgefhrt
GUISetAccelerators($aAccelKeys, $hGui)

GUIRegisterMsg($WM_SIZE, '_WM_SIZE')
GUIRegisterMsg($WM_MOVE, '_WM_MOVE')
GUIRegisterMsg($WM_GETMINMAXINFO, '_WM_GETMINMAXINFO')
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
GUIRegisterMsg($WM_COMMAND, '_WM_COMMAND')

WinMove($hGui, '', $iLeft, $iTop, $iWidth, $iHeight)

While Sleep(500)
	$iSelCount = _GUICtrlListView_GetSelectedCount($hLVHandle) ; Anzahl der markierten Items holen
	If $iSelCount <> $iSelOld Then ; vergleichen ob der Wert vom vorherigen abweicht (Flackern vermeiden)
		$iSelOld = $iSelCount ; wenn ja, dann alten gleich neuen Wert
		If $iSelCount > 0 Then ; wenn Eintrge markiert sind
			GUICtrlSetState($hDel, $GUI_ENABLE) ; dann Button aktivieren
			GUICtrlSetState($hDelFiles, $GUI_ENABLE) ; dann Button aktivieren
			GUICtrlSetState($hCopyFiles, $GUI_ENABLE) ; dann Button aktivieren
			GUICtrlSetState($hMoveFiles, $GUI_ENABLE) ; dann Button aktivieren
		Else ; keine Eintrge markiert
			GUICtrlSetState($hDel, $GUI_DISABLE) ; dann Button deaktivieren
			GUICtrlSetState($hDelFiles, $GUI_DISABLE) ; dann Button deaktivieren
			GUICtrlSetState($hCopyFiles, $GUI_DISABLE) ; dann Button deaktivieren
			GUICtrlSetState($hMoveFiles, $GUI_DISABLE) ; dann Button deaktivieren
		EndIf
	EndIf
WEnd

Func _End()
;~ 	If MsgBox(32 + 4, 'Save', 'Wollen sie vor dem beenden noch Speichern?') = 6 Then Save()
	IniWrite($sInifile, 'Config', 'FolderOpt', Number(BitAND(GUICtrlRead($hFolderOpt[1]), $GUI_CHECKED) = $GUI_CHECKED))
	Exit ; Programm beenden
EndFunc   ;==>_End

Func _ScanDrives()
	Local $aDrives
	$aDrives = DriveGetDrive('FIXED') ; Alle Festplatten-Buchstaben holen
	If @error Then Return
	_GUICtrlListView_DeleteAllItems($hLVHandle) ; Alle Listview-Eintrge lschen
	_GUICtrlStatusBar_SetText($hStatus, 0, 1)
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_MARQUEE)
	_SendMessage(GUICtrlGetHandle($hProgress), $PBM_SETMARQUEE, True, 20)
	For $i = 1 To $aDrives[0] ; Alle Festplatten durchgehen
		_GUICtrlStatusBar_SetText($hStatus, 'Durchsuche Festplatte  "' & StringUpper($aDrives[$i]) & '\"', 0)
		_DriveSearch(StringUpper($aDrives[$i]))
	Next
	GUISetCursor(2, 1, $hGui)
	_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
	_GUICtrlStatusBar_SetText($hStatus, '', 2)
	If $fStop Then
		$fStop = False
		_GUICtrlStatusBar_SetText($hStatus, 'Abgebrochen!', 0)
	Else
		_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	EndIf
	_PlayDefaultSystemSound('SystemAsterisk')
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_ScanDrives

Func _ScanFolder()
	Local $sPath = FileSelectFolder('Verzeichnis auswhlen!', '', 2, '', $hGui)
	If Not FileExists($sPath) Then Return
	_GUICtrlListView_DeleteAllItems($hLVHandle) ; Alle Listview-Eintrge lschen
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_MARQUEE)
	_SendMessage(GUICtrlGetHandle($hProgress), $PBM_SETMARQUEE, True, 20)
	_GUICtrlStatusBar_SetText($hStatus, 'Durchsuche Verzeichnis  "' & $sPath & '"', 0)
	_DriveSearch($sPath)
	GUISetCursor(2, 1, $hGui)
	_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
	_GUICtrlStatusBar_SetText($hStatus, '', 2)
	If $fStop Then
		$fStop = False
		_GUICtrlStatusBar_SetText($hStatus, 'Abgebrochen!', 0)
	Else
		_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	EndIf
	_PlayDefaultSystemSound('SystemAsterisk')
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	GUICtrlSetData($hProgress, 0)
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_ScanFolder

Func _DriveSearch($sPath)
	Local $aNewMP3, $aID3Tags, $sNewItem, $aItem, $iTimer = TimerInit(), $iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	_GUICtrlStatusBar_SetText($hStatus, 'Bitte warten...', 2)
	$aNewMP3 = _RecursiveFileListToArray($sPath, '\.mp3', 1) ; Alle MP3s auf der Festplatte auslesen
	If Not @error And $aNewMP3[0] > 0 Then
		GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
		_GUICtrlListView_SetItemCount($hListView, $iCount + $aNewMP3[0])
		_GUICtrlStatusBar_SetText($hStatus, 'Lese ID3-Tags... (' & $aNewMP3[0] & ')', 0)
		For $j = 1 To $aNewMP3[0] ; die gefundenen MP3s durchgehen
			GUICtrlSetData($hProgress, 100 / $aNewMP3[0] * $j)
			$aID3Tags = _ReadID3Tag($aNewMP3[$j]) ; die ID3-Tags auslesen
			If IsArray($aID3Tags) Then
				For $k = 0 To 10
					$aID3Tags[$k][1] = StringReplace($aID3Tags[$k][1], '|', '') ; evtl. vorhandene "|" entfernen
				Next
				If TimerDiff($iTimer) > 50 Then
					$iTimer = TimerInit()
					_GUICtrlStatusBar_SetText($hStatus, $iCount + $j, 1)
					_GUICtrlStatusBar_SetText($hStatus, $aNewMP3[$j], 2)
				EndIf
				$sNewItem = $aID3Tags[0][1] & '|' & $aID3Tags[1][1] & '|' & $aID3Tags[4][1] & '|' & $aID3Tags[2][1] & '|' & $aID3Tags[3][1]
				$sNewItem &= '|' & $aID3Tags[8][1] & '|' & $aID3Tags[9][1] & '|' & $aID3Tags[10][1] & '|' & $aNewMP3[$j]
				GUICtrlCreateListViewItem($sNewItem, $hListView)
			EndIf
			If $fStop Then ExitLoop
		Next
		_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
	EndIf
EndFunc   ;==>_DriveSearch

Func _SortList()
	Local $iTimer, $iCount
	If _GUICtrlListView_GetItemCount($hLVHandle) > 0 Then
		GUISetCursor(15, 1, $hGui)
		$iTimer = TimerInit()
		_GUICtrlStatusBar_SetText($hStatus, '', 2)
		_GUICtrlStatusBar_SetText($hStatus, 'Sortiere Daten! Bitte warten...', 0)
		GUICtrlSetStyle($hProgress, $PBS_MARQUEE)
		_SendMessage(GUICtrlGetHandle($hProgress), $PBM_SETMARQUEE, True, 20)
		If Not IsArray($aListview) Then
			$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
			Dim $aListview[$iCount][9]
			For $i = 0 To $iCount - 1
				For $j = 0 To 8
					$aListview[$i][$j] = ControlListView($hGui, '', $hListView, 'GetText', $i, $j)
				Next
			Next
		EndIf
		_ArraySort($aListview, 0, 0, 0, GUICtrlGetState($hListView))
		_GUICtrlListView_DeleteAllItems($hLVHandle)
		_GUICtrlListView_AddArray($hLVHandle, $aListview)
		_GUICtrlStatusBar_SetText($hStatus, _TicksToTimeFormat(TimerDiff($iTimer), '%mm:%ss.%ms') & ' (mm:ss.ms)', 2)
		_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
		_PlayDefaultSystemSound('SystemAsterisk')
		GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
		GUICtrlSetData($hProgress, 0)
		GUISetCursor(2, 1, $hGui)
	EndIf
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_SortList

Func _LoadList()
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	_GUICtrlStatusBar_SetText($hStatus, 'Lade Daten...', 0)
	_Load()
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	AdlibRegister('_ClearProgress', 500)
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	$aListview = ''
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_LoadList

Func _LoadListCheck()
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	_GUICtrlStatusBar_SetText($hStatus, 'Lade Daten...', 0)
	_Load(True)
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	AdlibRegister('_ClearProgress', 500)
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	$aListview = ''
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_LoadListCheck

Func _Load($fCheck = False) ; Datenbank-Datei laden
	Local $sDBFile, $hFile, $sContent, $aNewItems, $iTimer, $sFileName
	$sDBFile = FileOpenDialog('MP3-Datenbank-Datei auswhlen', @WorkingDir, 'MP3-Datenbank (*.db3)', 3, '', $hGui)
	If Not FileExists($sDBFile) Then Return
	$hFile = FileOpen($sDBFile, 0) ; Datei zum lesen ffnen
	If $hFile = -1 Then Return ; wenn das ffnen nicht erfolgreich war, dann Funktion verlassen
	$sContent = FileRead($hFile) ; Datei komplett einlesen
	FileClose($hFile) ; Datei schlieen
	$sContent = StringTrimRight($sContent, 2) ; das letzte @CRLF entfernen
	$aNewItems = StringSplit($sContent, @CRLF, 1) ; Den Dateiinhalt am Zeilenende splitten
	If Not IsArray($aNewItems) Then Return ; Wenn $aNewItems kein Array ist, dann Funktion verlassen
	_GUICtrlListView_DeleteAllItems($hLVHandle)
	_GUICtrlListView_SetItemCount($hLVHandle, $aNewItems[0])
	_GUICtrlStatusBar_SetText($hStatus, 'Lade Daten... (' & $aNewItems[0] & ')', 0)
	_GUICtrlListView_BeginUpdate($hLVHandle) ; Listview sperren
	$iTimer = TimerInit()
	For $i = 1 To $aNewItems[0] ; Alle Eintrge des Arrays durchgehen
		If TimerDiff($iTimer) > 100 Then
			$iTimer = TimerInit()
			GUICtrlSetData($hProgress, 100 / $aNewItems[0] * $i)
			_GUICtrlStatusBar_SetText($hStatus, $i, 1)
		EndIf
		GUICtrlCreateListViewItem($aNewItems[$i], $hListView) ; mit den eingelesenen Daten einen neuen Listview-Eintrag erstellen
		If $fCheck Then
			$sFileName = StringMid($aNewItems[$i], StringInStr($aNewItems[$i], '|', 0, -1) + 1)
			If Not FileExists($sFileName) Then GUICtrlSetColor(-1, 0xff2222)
		EndIf
	Next
	GUICtrlSetData($hProgress, 100)
	_GUICtrlStatusBar_SetText($hStatus, $i, 1)
	_GUICtrlListView_EndUpdate($hLVHandle) ; Listview wieder freigeben
EndFunc   ;==>_Load

Func _SaveList()
	Local $iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	If $iCount = 0 Then Return ; Wenn das Listview keine Eintrge enthlt, dann Funktion verlassen
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	_GUICtrlStatusBar_SetText($hStatus, 'Speichere Daten...', 0)
	_Save()
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	_GUICtrlStatusBar_SetText($hStatus, '', 2)
	AdlibRegister('_ClearProgress', 500)
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_SaveList

Func _Save() ; Datenbank-Datei speichern
	Local $sDBFile, $hFile, $iCount, $iTimer, $iCount
	$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	$sDBFile = FileSaveDialog('MP3-Datenbank-Datei auswhlen', '', 'MP3-Datenbank (*.db3)', 18, '', $hGui)
	If @error Then Return
	If StringRight($sDBFile, 4) <> '.db3' Then $sDBFile &= '.db3'
	$hFile = FileOpen($sDBFile, 2) ; Datei zum speichern (berschreiben) ffnen
	If $hFile = -1 Then Return; wenn das ffnen nicht erfolgreich war, dann Funktion verlassen
	$iTimer = TimerInit()
	For $i = 0 To $iCount - 1 ; Schleife, um alle Listview-Eintrge durchzugehen
		FileWriteLine($hFile, _GUICtrlListView_GetItemTextString($hLVHandle, $i))
		If TimerDiff($iTimer) > 100 Then
			$iTimer = TimerInit()
			GUICtrlSetData($hProgress, 100 / $iCount * $i)
			_GUICtrlStatusBar_SetText($hStatus, $i + 1, 2)
		EndIf
	Next
	GUICtrlSetData($hProgress, 100)
	FileClose($hFile) ; Datei schlieen
EndFunc   ;==>_Save

Func _RemoveEmptyFolder()
	Local $sRootPath, $aFolder
	$sRootPath = FileSelectFolder('Verzeichnis auswhlen!' & @CR & 'Achtung! Alle leeren Unterverzeichnisse werden automatisch gelscht.', '', 2, '', $hGui)
	If Not FileExists($sRootPath) Then Return
	$aFolder = _RecursiveFileListToArray($sRootPath, '', 2)
	If $aFolder[0] = 0 Then Return _PlayDefaultSystemSound('SystemHand')
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 1 To $aFolder[0]
		GUICtrlSetData($hProgress, 100 / $aFolder[0] * $i)
		If DirGetSize($aFolder[$i]) = 0 Then DirRemove($aFolder[$i], 1)
	Next
	_PlayDefaultSystemSound('SystemAsterisk')
	AdlibRegister('_ClearProgress')
	GUISetCursor(2, 1, $hGui)
EndFunc   ;==>_RemoveEmptyFolder

Func _RemoveMark()
	If MsgBox(256 + 32 + 4, 'Markierte Eintrge entfernen', 'Wollen sie wirklich die markierten Eintrge aus der Liste entfernen?', 0, $hGui) = 6 Then
		GUISetCursor(15, 1, $hGui)
		_GUICtrlListView_DeleteItemsSelected($hLVHandle)
		_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
		_PlayDefaultSystemSound('SystemAsterisk')
		GUISetCursor(2, 1, $hGui)
		$aListview = ''
		GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
	EndIf
EndFunc   ;==>_RemoveMark

Func _DeleteFiles()
	Local $aSelected, $sFileName
	If MsgBox(256 + 32 + 4, 'Markierte Dateien lschen', 'Wollen sie wirklich die markierten Dateien von der Festplatte lschen?', 0, $hGui) = 6 Then
		$aSelected = _GUICtrlListView_GetSelectedIndices($hLVHandle, True)
		GUISetCursor(15, 1, $hGui)
		GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
		For $i = 1 To $aSelected[0]
			GUICtrlSetData($hProgress, 100 / $aSelected[0] * $i)
			$sFileName = ControlListView($hGui, '', $hListView, 'GetText', $aSelected[$i], 8)
			FileRecycle($sFileName)
		Next
		_GUICtrlListView_DeleteItemsSelected($hLVHandle)
		_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
		_PlayDefaultSystemSound('SystemAsterisk')
		GUISetCursor(2, 1, $hGui)
		AdlibRegister('_ClearProgress')
		$aListview = ''
		GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
	EndIf
EndFunc   ;==>_DeleteFiles

Func _RemoveResChar($sText)
	Return StringRegExpReplace($sText, '[\?\/\*\\\<\>\:\|]', '')
EndFunc   ;==>_RemoveResChar

Func _AutoSortCopy()
	Local $iCount, $sRootPath, $sArtistPath, $sAlbumPath, $sCopyFile, $iRenCounter, $sNum, $sFileName
	$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	If $iCount = 0 Then Return _PlayDefaultSystemSound('SystemHand')
	$sRootPath = FileSelectFolder('Hauptverzeichnis auswhlen!' & @CR & 'Die weitere Verzeichnisstruktur wird automatisch erstellt.', '', 3, '', $hGui)
	If Not FileExists($sRootPath) Then Return
	If StringRight($sRootPath, 1) <> '\' Then $sRootPath &= '\'
	GUISetCursor(15, 1, $hGui)
	_GUICtrlStatusBar_SetText($hStatus, 'Kopiere MP3s nach Verzeichnisstruktur...', 0)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 0 To $iCount - 1
		GUICtrlSetData($hProgress, 100 / $iCount * ($i + 1))
		_GUICtrlStatusBar_SetText($hStatus, $i + 1, 2)
		If BitAND(GUICtrlRead($hFolderOpt[1]), $GUI_CHECKED) Then
			$sAlbumPath = StringStripWS( _RemoveResChar(ControlListView($hGui, '', $hListView, 'GetText', $i, 3)), 7)
			If $sAlbumPath = '' Then $sAlbumPath = 'unbekanntes Album'
			$sAlbumPath &= '\'
		Else
			$sAlbumPath = ''
		EndIf
		$sArtistPath = StringStripWS(_RemoveResChar(ControlListView($hGui, '', $hListView, 'GetText', $i, 1)), 7)
		If $sArtistPath = '' Then $sArtistPath = 'unbekannter Interpret'
		$sArtistPath &= '\'
		$sCopyFile = ControlListView($hGui, '', $hListView, 'GetText', $i, 8)
		$sFileName = StringRegExpReplace($sCopyFile, '.+\\(.+\.mp3)', '$1')
		$sFileName = _GetUniqueFileName($sRootPath & $sArtistPath & $sAlbumPath & $sFileName)
		FileCopy($sCopyFile, $sFileName, 8)
	Next
	_PlayDefaultSystemSound('SystemAsterisk')
	_GUICtrlStatusBar_SetText($hStatus, '', 2)
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	GUICtrlSetData($hProgress, 0)
	GUISetCursor(2, 1, $hGui)
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_AutoSortCopy

Func _AutoSortMove()
	Local $iCount, $sRootPath, $sArtistPath, $sAlbumPath, $sCopyFile, $iRenCounter, $sNum, $sFileName
	$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	If $iCount = 0 Then Return _PlayDefaultSystemSound('SystemHand')
	$sRootPath = FileSelectFolder('Hauptverzeichnis auswhlen!' & @CR & 'Die weitere Verzeichnisstruktur wird automatisch erstellt.', '', 3, '', $hGui)
	If Not FileExists($sRootPath) Then Return
	If StringRight($sRootPath, 1) <> '\' Then $sRootPath &= '\'
	GUISetCursor(15, 1, $hGui)
	_GUICtrlStatusBar_SetText($hStatus, 'Verschiebe MP3s nach Verzeichnisstruktur...', 0)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 0 To $iCount - 1
		GUICtrlSetData($hProgress, 100 / $iCount * ($i + 1))
		_GUICtrlStatusBar_SetText($hStatus, $i + 1, 2)
		If BitAND(GUICtrlRead($hFolderOpt[1]), $GUI_CHECKED) Then
			$sAlbumPath = StringStripWS(_RemoveResChar(ControlListView($hGui, '', $hListView, 'GetText', $i, 3)), 7)
			If $sAlbumPath = '' Then $sAlbumPath = 'unbekanntes Album'
			$sAlbumPath &= '\'
		Else
			$sAlbumPath = ''
		EndIf
		$sArtistPath = StringStripWS(_RemoveResChar(ControlListView($hGui, '', $hListView, 'GetText', $i, 1)), 7)
		If $sArtistPath = '' Then $sArtistPath = 'unbekannter Interpret'
		$sArtistPath &= '\'
		$sCopyFile = ControlListView($hGui, '', $hListView, 'GetText', $i, 8)
		$sFileName = StringRegExpReplace($sCopyFile, '.+\\(.+\.mp3)', '$1')
		$sFileName = _GetUniqueFileName($sRootPath & $sArtistPath & $sAlbumPath & $sFileName)
		If FileMove($sCopyFile, $sFileName, 8) Then _GUICtrlListView_SetItemText($hLVHandle, $i, $sFileName, 8)
	Next
	_PlayDefaultSystemSound('SystemAsterisk')
	_GUICtrlStatusBar_SetText($hStatus, '', 2)
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	GUICtrlSetData($hProgress, 0)
	GUISetCursor(2, 1, $hGui)
	$aListview = ''
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_AutoSortMove

Func _CopyFiles()
	Local $aSelected, $sCopyFile, $sPath, $sFileName
	$sPath = FileSelectFolder('Dateien kopieren - Zielverzeichnis auswhlen!', '', 3, '', $hGui)
	If Not FileExists($sPath) Then Return
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	$aSelected = _GUICtrlListView_GetSelectedIndices($hLVHandle, True)
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 1 To $aSelected[0]
		GUICtrlSetData($hProgress, 100 / $aSelected[0] * $i)
		$sCopyFile = ControlListView($hGui, '', $hListView, 'GetText', $aSelected[$i], 8)
		$sFileName = _GetUniqueFileName($sCopyFile)
		FileCopy($sCopyFile, $sFileName, 8)
	Next
	GUICtrlSetData($hProgress, 100)
	AdlibRegister('_ClearProgress')
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_CopyFiles

Func _MoveFiles()
	Local $aSelected, $sCopyFile, $sPath, $sFileName
	$sPath = FileSelectFolder('Dateien verschieben - Zielverzeichnis auswhlen!', '', 3, '', $hGui)
	If Not FileExists($sPath) Then Return
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	$aSelected = _GUICtrlListView_GetSelectedIndices($hLVHandle, True)
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 1 To $aSelected[0]
		GUICtrlSetData($hProgress, 100 / $aSelected[0] * $i)
		$sCopyFile = ControlListView($hGui, '', $hListView, 'GetText', $aSelected[$i], 8)
		$sFileName = _GetUniqueFileName($sCopyFile)
		If FileMove($sCopyFile, $sFileName, 8) Then _GUICtrlListView_SetItemText($hLVHandle, $aSelected[$i], $sFileName, 8)
	Next
	_GUICtrlStatusBar_SetText($hStatus, _GUICtrlListView_GetItemCount($hLVHandle), 1)
	GUICtrlSetData($hProgress, 100)
	AdlibRegister('_ClearProgress')
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	$aListview = ''
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_MoveFiles

Func _ClearProgress()
	AdlibUnRegister('_ClearProgress')
	GUICtrlSetData($hProgress, 0)
EndFunc   ;==>_ClearProgress

Func _NewList()
	If MsgBox(256 + 32 + 4, 'Liste erstellen', 'Wollen sie wirklich eine neue Liste erstellen?', 0, $hGui) = 6 Then
		_GUICtrlListView_DeleteAllItems($hLVHandle)
		_GUICtrlStatusBar_SetText($hStatus, 0, 1)
		$aListview = ''
		GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
	EndIf
EndFunc   ;==>_NewList

Func _ProgInfos()
	Local $sMsg
	$sMsg = 'Version:\t%s\nDatum:\t%s\nProgrammierer:\tOscar (www.autoit.de)\nIdee und Betatest:\tSkilkor (www.autoit.de)\n\n'
	$sMsg &= 'Danksagung:\nfunkey (www.autoit.de) fr die Funktion "_PlayDefaultSystemSound".\n\n'
	$sMsg &= 'Wesentliche Programmeigenschaften:\nMit diesem Programm kann man nach MP3-Dateien suchen lassen.\n'
	$sMsg &= 'Von den MP3s werden diverse Informationen (ID3-Tags) gelesen und in einer Liste dargestellt. '
	$sMsg &= 'Diese Liste kann man abspeichern, um sie spter wiederverwenden zu knnen.\n'
	$sMsg &= 'Anhand dieser Liste kann man die MP3-Dateien in eine Verzeichnisstruktur kopieren/verschieben lassen.\n'
	$sMsg &= 'Es gibt aber auch eine Suchfunktion innerhalb dieser Liste (das Ergebnis wird in einer eigenen Liste angezeigt).\n'
	$sMsg &= 'Mit einem Doppelklick auf einen Eintrag in der Liste wird die entsprechende MP3-Datei abgespielt.\n'
	$sMsg &= 'Markierte Dateien knnen kopiert, verschoben oder gelscht (in den Papierkorb verschoben) werden.\n'
	MsgBox(64, $sTitle, StringFormat($sMsg, $sVersion, $sDate), 0, $hGui)
EndFunc   ;==>_ProgInfos

Func _Stop()
	$fStop = True
EndFunc   ;==>_Stop

Func _SearchList()
	Local $iCount
	$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	If $iCount = 0 Or GUICtrlRead($hInput) = '' Then Return _PlayDefaultSystemSound('SystemHand')
	ControlFocus($hGui, '', $hInputOk)
	_GUICtrlStatusBar_SetText($hStatus, 'Suche in Liste...', 0)
	GUISetCursor(15, 1, $hGui)
	_LVSearch()
	_PlayDefaultSystemSound('SystemAsterisk')
	GUISetCursor(2, 1, $hGui)
	_GUICtrlStatusBar_SetText($hStatus, 'Fertig.', 0)
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
EndFunc   ;==>_SearchList

Func _LVSearch()
	Local $sSearch, $iTimer, $iCount, $iCase, $iFound, $sMsg = ' Eintrge'
	$iCount = _GUICtrlListView_GetItemCount($hLVHandle)
	$sSearch = GUICtrlRead($hInput)
	If $sSearch = '' Then Return
	_GUICtrlListView_SetItemSelected($hLVHandle, -1, False)
	_GUICtrlListView_DeleteAllItems($hSearchLVHandle)
	$iCase = Number(BitAND(GUICtrlRead($hCaseSens), $GUI_CHECKED) = $GUI_CHECKED)
	$iTimer = TimerInit()
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetStyle($hProgress, $PBS_SMOOTH)
	For $i = 0 To $iCount - 1
		$sItem = ''
		For $j = 0 To 8
			$sItem &= ControlListView($hGui, '', $hListView, 'GetText', $i, $j) & '|'
		Next
		If StringInStr($sItem, $sSearch, $iCase) Then GUICtrlCreateListViewItem(StringTrimRight($sItem, 1), $hSearchListView)
		If TimerDiff($iTimer) > 100 Then
			$iTimer = TimerInit()
			GUICtrlSetData($hProgress, 100 / $iCount * $i)
			_GUICtrlStatusBar_SetText($hStatus, $i, 2)
		EndIf
	Next
	GUICtrlSetState($hInputOk, $GUI_DISABLE)
	$iFound = _GUICtrlListView_GetItemCount($hSearchLVHandle)
	If $iFound = 1 Then $sMsg = ' Eintrag'
	_GUICtrlStatusBar_SetText($hStatus, $iFound & $sMsg & ' gefunden', 2)
	If $iFound Then
		GUICtrlSetBkColor($hInput, 0xaaffaa)
		GUICtrlSetState($hSearchListView, $GUI_SHOW)
		GUICtrlSetState($hListView, $GUI_HIDE)
	Else
		GUICtrlSetBkColor($hInput, 0xffaaaa)
	EndIf
	GUICtrlSetData($hProgress, 100)
	AdlibRegister('_ClearProgress')
	GUISetCursor(2, 1, $hGui)
EndFunc   ;==>_LVSearch

Func _WM_COMMAND($hWnd, $msg, $wParam, $lParam)
	Local $nNotifyCode = BitShift($wParam, 16)
	Local $nID = BitAND($wParam, 0xFFFF)
	If $nID = $hInput And $nNotifyCode = 256 Then
		GUICtrlSetState($hSearchListView, $GUI_HIDE)
		GUICtrlSetState($hListView, $GUI_SHOW)
		GUICtrlSetBkColor($hInput, 0xffffff)
		GUICtrlSetData($hInput, '')
		GUICtrlSetState($hInputOk, $GUI_ENABLE)
		_GUICtrlStatusBar_SetText($hStatus, '', 2)
		_GUICtrlListView_SetItemSelected($hLVHandle, -1, False)
	EndIf
	GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_COMMAND

Func _WM_NOTIFY($hWnd, $msg, $wParam, $lParam)
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $iSelected, $sExecutePath
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	$iCode = DllStructGetData($tNMHDR, 'Code')
	Switch $hWndFrom
		Case $hLVHandle
			Switch $iCode
				Case $NM_DBLCLK
					$iSelected = ControlListView($hGui, '', $hListView, 'GetSelected')
					$sExecutePath = _GUICtrlListView_GetItemText($hLVHandle, $iSelected, 8)
					ShellExecute($sExecutePath)
				Case $NM_CLICK
					GUICtrlSetData($hShowMark, ControlListView($hGui, '', $hListView, 'GetSelectedCount'))
			EndSwitch
		Case $hSearchLVHandle
			Switch $iCode
				Case $NM_DBLCLK
					$iSelected = ControlListView($hGui, '', $hSearchListView, 'GetSelected')
					$sExecutePath = _GUICtrlListView_GetItemText($hSearchLVHandle, $iSelected, 8)
					ShellExecute($sExecutePath)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _WM_SIZE($hWnd, $msg, $wParam, $lParam)
	Local $aGuiPos = WinGetPos($hGui)
	If Not BitAND(WinGetState($hGui), 16) Then
		IniWrite($sInifile, 'Config', 'Width', $aGuiPos[2])
		IniWrite($sInifile, 'Config', 'Height', $aGuiPos[3])
	EndIf
	_GUICtrlStatusBar_Resize($hStatus)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE

Func _WM_MOVE($hWnd, $msg, $wParam, $lParam)
	Local $aGuiPos = WinGetPos($hGui)
	If Not BitAND(WinGetState($hGui), 16) Then
		IniWrite($sInifile, 'Config', 'Left', $aGuiPos[0])
		IniWrite($sInifile, 'Config', 'Top', $aGuiPos[1])
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_MOVE

Func _WM_GETMINMAXINFO($hWnd, $msg, $wParam, $lParam)
	If $hWnd = $hGui Then
		Local $minmaxinfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
		DllStructSetData($minmaxinfo, 7, 786) ; min X
		DllStructSetData($minmaxinfo, 8, 444) ; min Y
;~         DllStructSetData($minmaxinfo, 9, 800) ; max X
;~         DllStructSetData($minmaxinfo, 10, 800) ; max Y
	EndIf
EndFunc   ;==>_WM_GETMINMAXINFO

;===============================================================================
; Function Name:   _GetUniqueFileName($sPath)
; Description::    Wenn der Dateiname bereits existiert wird ein Zhler
;                  in Form von: "_(1)" an den Dateinamen angehngt.
; Parameter(s):    $sPath = kompletter Pfad der Datei
; Requirement(s):  -
; Return Value(s): bei Erfolg = der (neue) Dateiname
;                  bei Fehler wird @error = 1 (Pfad falsch angegeben)
; Author(s):       Oscar (www.autoit.de)
;===============================================================================
Func _GetUniqueFileName($sPath)
	Local $aPath, $sNumber = '', $iCount = 0
	$aPath = StringRegExp($sPath, '(.+\\)(.+)(\..+)', 3)
	If @error Then Return SetError(1, 0, 0)
	While FileExists($aPath[0] & $aPath[1] & $sNumber & $aPath[2])
		$iCount += 1
		$sNumber = '_(' & $iCount & ')'
	WEnd
	Return $aPath[0] & $aPath[1] & $sNumber & $aPath[2]
EndFunc   ;==>_GetUniqueFileName

;===============================================================================
; Function Name:   _RecursiveFileListToArray($sPath[, $sPattern][, $iFlag][, $iFormat][, $iRecursion][, $sDelim])
; Description::    gibt Verzeichnisse (rekursiv) und/oder Dateien zurck, die einem RegExp-Pattern entsprechen
; Parameter(s):    $sPath = Startverzeichnis
;                  $sPattern = ein beliebiges RexExp-Pattern fr die Auswahl
;                  $iFlag = Auswahl
;                           0 = Dateien & Verzeichnisse
;                           1 = nur Dateien
;                           2 = nur Verzeichnisse
;                  $iFormat = Rckgabeformat
;                             0 = String
;                             1 = Array mit [0] = Anzahl
;                             2 = Nullbasiertes Array
;                  $iRecursion = Verzeichnisse rekursiv durchsuchen
;                                0 = Nein
;                                1 = Ja
;                  $sDelim = Trennzeichen fr die String-Rckgabe
; Requirement(s):  AutoIt 3.3.0.0
; Return Value(s): Array/String mit den gefundenen Dateien/Verzeichnissen
; Author(s):       Oscar (www.autoit.de)
;                  Anregungen von: bernd670 (www.autoit.de)
;===============================================================================
Func _RecursiveFileListToArray($sPath, $sPattern = '', $iFlag = 0, $iFormat = 1, $iRecursion = 1, $sDelim = @CRLF)
	Local $hSearch, $sFile, $sReturn = ''
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	$hSearch = FileFindFirstFile($sPath & '*.*')
	If @error Or $hSearch = -1 Then Return SetError(1, 0, $sReturn)
	While Not $fStop
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If @extended Then
			If StringInStr(FileGetAttrib($sPath & $sFile), 'S') = 0 Then
				If StringRegExp($sPath & $sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 2) Then $sReturn &= $sPath & $sFile & '\' & $sDelim
				If $iRecursion Then $sReturn &= _RecursiveFileListToArray($sPath & $sFile & '\', $sPattern, $iFlag, 0)
				ContinueLoop
			EndIf
		EndIf
		If StringInStr(FileGetAttrib($sPath & $sFile), 'S') = 0 Then
			If StringRegExp($sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 1) Then $sReturn &= $sPath & $sFile & $sDelim
		EndIf
	WEnd
	FileClose($hSearch)
	If $iFormat And $sReturn = '' Then Return StringSplit($sReturn, '', $iFormat)
	If $iFormat Then Return StringSplit(StringTrimRight($sReturn, StringLen($sDelim)), $sDelim, $iFormat)
	Return $sReturn
EndFunc   ;==>_RecursiveFileListToArray

;===============================================================================
; Function Name:   _ReadID3Tag($sPath)
; Description::    gibt ein Array mit den Daten aus den ID3-Tags zurck
;                  untersttzt werden die ID3-Tag-Versionen 1.0, 1.1, 2.3 und 2.4
;                  bei v2.4 mssen sich die ID3-Tags am Anfang der Datei befinden
; Parameter(s):    $sPath = Pfad zu einer MP3-Datei
; Requirement(s):  min. AutoIt v3.3.0.0
; Return Value(s): bei Erfolg: Array mit den ID3-Tagdaten (@error = 0)
;                  im Fehlerfall bekommt @error:
;                  1 = Datei existiert nicht
;                  2 = Datei konnte nicht zum lesen geffnet werden
;                  3 = falsche ID3 v2 Version
;                  4 = Datei ist keine MP3-Datei
; Author(s):       Oscar (www.autoit.de)
;===============================================================================
Func _ReadID3Tag($sPath)
	If Not FileExists($sPath) Then Return SetError(1, 0, 0)
	Local $hFile, $sData, $sID3Header, $iID3HeaderSize = 0, $iOffset, $iSize, $tmp
	Local $aID3v2Tags[8] = ['TIT2', 'TPE1', 'TALB', 'TYER', 'TLEN', 'TRCK', 'TCON', 'TENC']
	Local $aID3[11][2] = [ _
			['Title', ''],['Artist', ''],['Album', ''],['Year', ''], _
			['Length', '0'],['Track', ''],['Genre', ''],['Encoder', ''], _
			['MPEG-Version', ''],['Bitrate', '-'],['Sample-Freq.', '']]
	Local $aMP3Version[4] = ['MPEG2.5', 'Reserved', 'MPEG2', 'MPEG1']
	Local $aMP3Layer[4] = ['Reserved', 'Layer III', 'Layer II', 'Layer I']
	Local $aMP3Bitrate[5][16] = [ _
			[000, 032, 064, 096, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448, 000], _
			[000, 032, 048, 056, 064, 080, 096, 112, 128, 160, 192, 224, 256, 320, 384, 000], _
			[000, 032, 040, 048, 056, 064, 080, 096, 112, 128, 160, 192, 224, 256, 320, 000], _
			[000, 032, 048, 056, 064, 080, 096, 112, 128, 144, 160, 176, 192, 224, 256, 000], _
			[000, 008, 016, 024, 032, 040, 048, 056, 064, 080, 096, 112, 128, 144, 160, 000]]
	Local $aSampleFreq[3][4] = [[44100, 48000, 32000, 0],[22050, 24000, 16000, 0],[11025, 12000, 8000, 0]]
	Local $sMP3FrameHeader, $iMP3Version, $sMP3Version, $sMP3Layer, $iMP3Bitrate, $iMP3SampleFreq
	Local $iVBRFrames = -1, $iVBRFilesize, $iVBRFlags
	$hFile = FileOpen($sPath, 16)
	If $hFile = -1 Then Return SetError(2, 0, 0)
	$sData = Binary(FileRead($hFile, 4))
	If BinaryMid($sData, 1, 3) = '0x494433' Then ; ID3 v2.x Kennung gefunden
		If (BinaryMid($sData, 4, 1) = '0x03') Or (BinaryMid($sData, 4, 1) = '0x04') Then ; nur v2.3 und 2.4
			FileRead($hFile, 2) ; 2 Bytes berspringen
			For $i = 0 To 3 ; berechne ID3-Headergre (4 Bytes, jedoch nur jeweils die unteren 7 Bit)
				$iID3HeaderSize = BitShift($iID3HeaderSize, -7) + BitAND(Binary(FileRead($hFile, 1)), 0x7F)
			Next
			If $iID3HeaderSize > 0 Then
				$sID3Header = Binary(FileRead($hFile, $iID3HeaderSize)) ; lese gesamten ID3-Header
				For $i = 0 To 7
					$iOffset = StringInStr(BinaryToString($sID3Header), $aID3v2Tags[$i]) ; Offset zu dem ID3-Tag
					If $iOffset > 0 Then
						$iSize = Hex(BinaryMid($sID3Header, $iOffset + 4, 4)) ; Gre des ID3-Frames
						$tmp = BinaryMid($sID3Header, $iOffset + 11, Dec($iSize) - 1)
						If BinaryMid($tmp, 1, 2) = '0xFFFE' Then
							For $x = 3 To BinaryLen($tmp) Step 2
								$aID3[$i][1] &= BinaryToString(BinaryMid($tmp, $x, 2), 2)
							Next
						Else
							For $x = 1 To BinaryLen($tmp)
								$aID3[$i][1] &= BinaryToString(BinaryMid($tmp, $x, 1))
							Next
						EndIf
						$aID3[$i][1] = StringReplace($aID3[$i][1], Chr(0), '')
					EndIf
				Next
			EndIf
			Do
				$sData = String(FileRead($hFile, 1))
				If @error Then ExitLoop
				If BitAND($sData, 0xff) = 0xff Then
					FileSetPos($hFile, -1, 1)
					$sData = String(FileRead($hFile, 4))
				EndIf
			Until BitAND($sData, 0xFFE00000) = 0xFFE00000
		Else
			FileClose($hFile)
			Return SetError(3, 0, 0)
		EndIf
	Else ; ID3 v1.x
		$iOffset = FileGetPos($hFile)
		FileSetPos($hFile, -128, 2)
		$sID3Header = BinaryToString(FileRead($hFile, 3))
		If $sID3Header = 'TAG' Then
			$aID3[0][1] = StringReplace(BinaryToString(FileRead($hFile, 30)), Chr(0), '')
			$aID3[1][1] = StringReplace(BinaryToString(FileRead($hFile, 30)), Chr(0), '')
			$aID3[2][1] = StringReplace(BinaryToString(FileRead($hFile, 30)), Chr(0), '')
			$aID3[3][1] = StringReplace(BinaryToString(FileRead($hFile, 4)), Chr(0), '')
		EndIf
		FileSetPos($hFile, $iOffset, 0)
	EndIf
	$sMP3FrameHeader = String($sData)
	If BitAND($sMP3FrameHeader, 0xFFE00000) <> 0xFFE00000 Then
		FileClose($hFile)
		Return SetError(4, 0, 0) ; keine MP3-Datei, dann Return
	EndIf
	$iMP3Version = BitShift(BitXOR($sMP3FrameHeader, 0xFFE00000), 19) ; welche MP3-Version
	$sMP3Version = $aMP3Version[$iMP3Version] ; in Textform
	$sMP3Layer = $aMP3Layer[BitShift(BitAND($sMP3FrameHeader, 0x60000), 17)] ; welcher Layer
	$aID3[8][1] = $sMP3Version & ' / ' & $sMP3Layer ; ins Ausgabe-Array
	$iMP3Bitrate = BitShift(BitAND($sMP3FrameHeader, 0xF000), 12) ; Bitraten-Index auslesen
	Switch $sMP3Version ; je nach MPEG-Version Bitrate aus der Tabelle holen
		Case 'MPEG1'
			$aID3[9][1] = $aMP3Bitrate[$iMP3Version - ($iMP3Version > 1)][$iMP3Bitrate]
		Case 'MPEG2', 'MPEG2.5'
			If $sMP3Layer = 'Layer I' Then
				$aID3[9][1] = $aMP3Bitrate[3][$iMP3Bitrate]
			Else
				$aID3[9][1] = $aMP3Bitrate[4][$iMP3Bitrate]
			EndIf
	EndSwitch
	$iMP3SampleFreq = BitShift(BitAND($sMP3FrameHeader, 0xC00), 10) ; Sample-Frequenz-Index auslesen
	$aID3[10][1] = $aSampleFreq[2 - ($iMP3Version - ($iMP3Version > 1))][$iMP3SampleFreq] ; und Wert aus der Tabelle holen
	Do ; evtl. Leerbytes berspringen
		$tmp = FileRead($hFile, 1)
		If @error Then ExitLoop
	Until $tmp <> 0x00 Or @error
	If $tmp = 0x58 And BinaryToString(FileRead($hFile, 3)) = 'ing' Then ; MP3 mit VBR (Xing-Header gefunden)?
		$iVBRFlags = '0x' & Hex(FileRead($hFile, 4)) ; VBR-Flags auslesen
		If BitAND($iVBRFlags, 0x3) Then ; wenn die Eintrge vorhanden sind, dann...
			$iVBRFrames = Dec(Hex(FileRead($hFile, 4))) ; Anzahl der VBR-Frames auslesen
			$iVBRFilesize = Dec(Hex(FileRead($hFile, 4))) ; Dateigre auslesen
			$aID3[4][1] = $iVBRFrames * 1152 / $aID3[10][1] * 1000 ; VBR Laufzeit
			$aID3[9][1] = 'VBR ~' & Int($iVBRFilesize * 8 / ($aID3[4][1] / 1000) / 1000) ; VBR durchschnittliche Bitrate
		EndIf
	Else
		If $aID3[4][1] = 0 Then $aID3[4][1] = (FileGetSize($sPath) * 8) / ($aID3[9][1] * 1000) * 1000 ; alternative CBR Laufzeit
		$aID3[9][1] = 'CBR ' & $aID3[9][1]
	EndIf
	$aID3[4][1] = _TicksToTimeFormat($aID3[4][1]) ; Laufzeit (Ticks to hour:min:sec)
	$aID3[9][1] &= ' kBit/s'
	$aID3[10][1] &= ' Hz'
	FileClose($hFile)
	Return SetError(0, 0, $aID3)
EndFunc   ;==>_ReadID3Tag

;===============================================================================
; Function Name:   _TicksToTimeFormat($iTicks, $sFormat = '%hh:%mm:%ss')
; Description::    Diese Funktion wandelt Millisekunden in ein anzugebenes Zeitformat um
; Parameter(s):    $iTicks = Zeit in Millisekunden
;                  $sFormat:
;                            %hh fr Stunden
;                            %mm fr Minuten
;                            %ss fr Sekunden
;                            %ms fr Millisekunden
;                            sonstige Zeichen, die dazwischen stehen, werden bernommen
; Requirement(s):  -
; Return Value(s): Zeit im ausgewhlten Format (String)
; Author(s):       Oscar (www.autoit.de)
;===============================================================================
Func _TicksToTimeFormat($iTicks, $sFormat = '%hh:%mm:%ss')
	Local $aTime[4] = [0, 0, 0, 0], $sOut, $aTimeFormat[4] = ['hh', 'mm', 'ss', 'ms'], $aFormat
	$aTime[2] = Int($iTicks / 1000)
	$aTime[3] = $iTicks - $aTime[2] * 1000
	$aTime[0] = Int($aTime[2] / 3600)
	$aTime[2] = Mod($aTime[2], 3600)
	$aTime[1] = Int($aTime[2] / 60)
	$aTime[2] = Mod($aTime[2], 60)
	$aFormat = StringRegExp($sFormat, '%([^%]+)', 3)
	If Not IsArray($aFormat) Then Return SetError(1, 0, $iTicks)
	For $i = 0 To UBound($aFormat) - 1
		For $j = 0 To UBound($aTimeFormat) - 1
			If StringLeft($aFormat[$i], 2) = $aTimeFormat[$j] Then $sOut &= StringFormat('%0' & 2 + ($j = 3) & 'i', $aTime[$j]) & StringMid($aFormat[$i], 3)
		Next
	Next
	Return $sOut
EndFunc   ;==>_TicksToTimeFormat

; #FUNCTION# ====================================================================================================================
; Name...........:    _PlayDefaultSystemSound()
; Description ...:    Spielt einen Systemklang, welcher in der Registry definiert ist.
; Syntax.........:    _PlayDefaultSystemSound($sSoundName, $iWait = 0)
; Parameters ....:    $sSoundName                - Name des SystemSound's
;                    | Default                   - Standardton Warnsignal / Default Beep
;                    | CriticalBatteryAlarm      - Alarm bei kritischem Batteriestand / when battery is critical
;                    | DeviceConnect            - Gerteanschlu / when a device is connect
;                    | DeviceDisconnect          - Gertetrennung / when a device is disconnect
;                    | DeviceFail                - Gerteanschlu fehlgeschlagen / when a deviceconnect is fail
;                    | LowBatteryAlarm           - Alarm bei niedrigem Batteriestand / when battery is low
;                    | MailBeep                  - Posteingangsbenachrichtigung / when email is received
;                    | SystemAsterisk            - Stern / Asterisk
;                    | SystemExclamation         - Hinweis / when windows shows a warning
;                    | SystemExit                - Windows beenden / when Windows shuts down
;                    | SystemHand                - Kritischer Abbruch / when a critical stop occurs
;                    | SystemNotification        - Sprechblase / when a critical stop occurs
;                    | SystemStart               - Windows starten / when Windows starts up
;                    | WindowsLogoff             - beim Windows abmelden / when logging off Windows
;                    | WindowsLogon              - beim Windows anmelden / when logging on Windows
;                    | EmptyRecycleBin           - Lschen des Papierkorbs / when recycle bin is emptied
;                    | Navigating                - Browser Klick / navigating in browser

;                     $iWait                     - Warten bis SoundPlay beendet? (0 = nein / 1 = ja)
; Return values .:    -----
; Author ........:    funkey (AutoIt.de)
; ===============================================================================================================================
Func _PlayDefaultSystemSound($sSoundName, $iWait = 0) ; funkey
	Local $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\.Default'
	If $sSoundName = 'EmptyRecycleBin' Or $sSoundName = 'Navigating' Then $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\Explorer'
	Local $sFile = StringReplace(RegRead($sKey & '\' & $sSoundName & '\.Default', ''), '%SystemRoot%', @WindowsDir)
	If $sFile = "" Then
		SoundPlay(StringReplace(RegRead($sKey & '\.Default\.Default', ''), '%SystemRoot%', @WindowsDir), $iWait)
	Else
		SoundPlay($sFile, $iWait)
	EndIf
EndFunc   ;==>_PlayDefaultSystemSound